# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section         free

Summary:        Reusable Daemon Framework
Name:           apacheds-daemon
Version:        1.0.0
Release:        2jpp
Epoch:          0
Group:          Applications/Internet
License:        Apache 2.0 License
URL:            http://directory.apache.org/
Source0:        %{name}-%{version}.tar.gz
# svn export http://svn.apache.org/repos/asf/directory/releases/daemon/1.0.0 apacheds-daemon-1.0.0

Source1:        directory-pom-1.0.4.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-settings.xml

Patch0:         apacheds-daemon-bootstrappers-pom_xml.patch
Patch1:         apacheds-daemon-plugin-pom_xml.patch

Vendor:         JPackage Project
Distribution:   JPackage
BuildRequires:  jpackage-utils >= 0:1.7.1
BuildRequires:  maven2 => 0:2.0.4
BuildRequires:  saxon
BuildRequires:  saxon-scripts
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  izpack
BuildRequires:  jakarta-commons-daemon
BuildRequires:  plexus-utils
BuildRequires:  slf4j
BuildRequires:  nlog4j
Requires:  jakarta-commons-daemon
Requires:  plexus-utils
Requires:  slf4j
Requires:  nlog4j

%if %{gcj_support}
BuildRequires:          gnu-crypto
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Reusable framework for daemon applications based on Commons
Daemon Jsvc and Procrun. A small installation layout pattern
combined with some utility classes allows applications to 
become UNIX daemons or Windows NT services.  Reusable
bootstrappers along with an installer plugin allow for the
rapid creation of standalone daemon applications.

%package bootstrappers
Group:          Applications/Internet
Summary:        Apache DS Daemon bootstrappers
Requires:       slf4j

%description bootstrappers
Daemon bootstrappers which initialize a classloader with 
jars laid out in an installation footprint.

%package maven2-plugin
Group:          Development/Libraries
Summary:        Build installers
Requires:       %{name}-bootstrappers = %{epoch}:%{version}-%{release}
Requires:       maven2 >= 0:2.0.4
Requires:       ant >= 0:1.6.5
Requires:       izpack
Requires:       plexus-utils

%description maven2-plugin
A plugin that builds installers using bootstrappers
and commons-daemon procrun and jsvc.

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description javadoc
%{summary}.

%prep
%setup -q -n %{name}-%{version}

%patch0 -b .sav
%patch1 -b .sav

%build
cp %{SOURCE3} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

for p in $(find . -name "*.pom"); do
    pushd $(dirname $p)
    bp=`basename $p`
    cp $bp $bp.orig
    /usr/bin/saxon -o $bp $bp.orig /usr/share/java-utils/xml/maven2jpp-mapdeps.xsl map=%{SOURCE2}
    popd
done

for p in $(find . -name "*pom.xml"); do
    pushd $(dirname $p)
    bp=`basename $p`
    cp $bp $bp.orig
    /usr/bin/saxon -o $bp $bp.orig /usr/share/java-utils/xml/maven2jpp-mapdeps.xsl map=%{SOURCE2}
    popd
done

mkdir -p m2_repo/repository/JPP/maven2/default_poms
cp %{SOURCE1} m2_repo/repository/JPP/maven2/default_poms/org.apache.directory-build.pom
cp pom.xml m2_repo/repository/JPP/maven2/default_poms/JPP-apacheds-daemon-build.pom

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

MVN=/usr/bin/mvn
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
export MAVEN_OPTS="-Dmaven.repo.local=$MAVEN_REPO_LOCAL -Dmaven2.jpp.mode=true -Dmaven.test.failure.ignore=true -Djava.awt.headless=true"
${MVN} -s ${M2SETTINGS} ${MAVEN_OPTS} install javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 bootstrappers/target/daemon-bootstrappers-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-bootstrappers-%{version}.jar
install -m 644 plugin/target/daemon-plugin-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/apacheds-daemon-maven2-plugin-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-apacheds-daemon-build.pom
install -m 644 bootstrappers/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-apacheds-daemon-bootstrappers.pom
install -m 644 plugin/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-apacheds-daemon-maven2-plugin.pom

# javadoc
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/bootstrappers
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/plugin
cp -pr bootstrappers/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/bootstrappers
cp -pr plugin/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/plugin
ln -sf %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} #ghost

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post bootstrappers
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun bootstrappers
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post maven2-plugin
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun maven2-plugin
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files bootstrappers
%defattr(0644,root,root,0755)
%doc bootstrappers/LICENSE.txt
%{_javadir}/%{name}-bootstrappers*.jar
%{_datadir}/maven2/poms/JPP-apacheds-daemon-build.pom
%{_datadir}/maven2/poms/JPP-apacheds-daemon-bootstrappers.pom
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-bootstrappers-%{version}.jar.*
%endif

%files maven2-plugin
%defattr(0644,root,root,0755)
%doc plugin/LICENSE.txt
%{_javadir}/%{name}-maven2-plugin*.jar
%{_datadir}/maven2/poms/JPP-apacheds-daemon-maven2-plugin.pom
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-maven2-plugin-%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%changelog
* Thu Mar 15 2007 Ralph Apel <r.apel at r-apel.de> 0:1.0.0-2jpp
- Provide initial pom in local repo
- Add nlog4j (B)R
- Add Requires for jakarta-commons-daemon, plexus-utils, slf4j, nlog4j

* Fri Oct 27 2006 Ralph Apel <r.apel at r-apel.de> 0:1.0.0-1jpp
- First release for apacheds-1.0.0
- Add post/postun Requires for javadoc
- Add gcj_support option
- FIXME: native integration pending
